<template>
  <ObForm
    :form-model="formModel"
    :form-data="formData"
    :dropdown-menu="dropdownMenu"
    class="form-add"
    ok-text="Сохранить"
    cancel-text="Отменить"
    @submit="onSubmit"
  >
  <div class="form-add__section">
      <div class="form-add__title">
        1. Выберите тип документа
      </div>

      <ObSelect
        :remote-opt="loadDocumentsTypes"
        :disabled="!!dataSource"
        v-model="formData.docTypeUuid"
        placeholder="Выберите из списка"
        label="Тип документа"
        display-exp="name"
        value-exp="uuid"
        required
      />
    </div>

    <div class="form-add__section">
      <template v-if="dataSource && existingFiles.length">
        <div class="form-add__title">
          2. Загруженные ранее сканы документа <span class="-light-raspberry-red">*</span>
        </div>

        <div class="existing-files">
          <div
            v-for="file in existingFiles"
            :key="file.uuid"
            class="existing-files__file"
          >
            {{ file.name }}

            <!-- <i
              @click="deleteFile(file.uuid)"
              class="icon close existing-files__icon"
            /> -->
          </div>
        </div>
      </template>

      <div class="form-add__title">
        <template v-if="!dataSource || !existingFiles.length">
          2. Загрузите скан документа <span class="-light-raspberry-red">*</span>
        </template>
        <!-- <template v-else>
          Загрузить ещё
        </template> -->
      </div>

      <ObUploader
        v-if="!dataSource"
        :is-detail-emit="true"
        :multiple="true"
        data-qa="uploader"
        @change="onChangeFiles($event)"
      />
    </div>

    <div class="form-add__section">
      <div class="form-add__title">
        3. Добавьте комментарий (необязательно)
      </div>

      <ObTextarea
        :disabled="!!dataSource"
        label="Комментарий"
        placeholder="Если хотите, можете добавить комментарий к загружаемому документу"
        v-model="formData.comment"
      />
    </div>
  </ObForm>
</template>

<script>
  import api from '@/api';
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
  import ObForm from 'common-components/src/obComponents/obForm';
  import ObSelect from 'common-components/src/obComponents/obSelect';
  import ObUploader from 'common-components/src/obComponents/obUploader';
  import ObTextarea from 'common-components/src/obComponents/obTextarea';
  import { uuid } from 'vue-uuid';
  import { required } from 'vuelidate/lib/validators';

  export default {
    name: 'documents-tab-document',
    mixins: [
      FormValidationMixin
    ],
    components: {
      ObForm,
      ObSelect,
      ObUploader,
      ObTextarea
    },
    props: {
      elementUuid: {
        type: String,
        required: true
      },
      type: {
        type: String,
        required: true
      }
    },
    computed: {
      formModel () {
        return {
          docTypeUuid: {
            validator: {
              required
            }
          },
          files: {
            value: [],
            validator: {
              required
            }
          },
          comment: {
            value: null
          }
        }
      },
      dropdownMenu () {
        return [
          {
            icon: 'trash',
            title: 'Удалить документ',
            className: 'menu-button-delete',
            isHidden: this.dataSource?.archivedAt !== null,
            method: this.deleteDocument
          }
        ]
      },
      existingFiles () {
        if (!this.formData.files) {
          return []
        }

        // Needed to showing only previously added files
        return this.formData.files.filter(file => this.dataSource.files.find(item => item.uuid === file.uuid));
      }
    },
    methods: {
      async loadDocumentsTypes () {
        try {
          return await api.organisations.loadDocumentsTypes();
        } catch (e) {
          console.error('Ошибка загрузки списка типов документов:', e);

          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных"
          });

          return [];
        }
      },
      selectedType (type) {
        this.formData.docTypeUuid = type
      },
      async onChangeFiles (event) {
        if (event.added) {
          await Promise.all(event.added.map(async (file) => {
            await api.files.postSecurityFile({
              uuid: file.uuid,
              participant_uuid: this.elementUuid,
              file: file.file
            });
          }));
        }

        this.formData.files = event.files;

        const ending = event.added?.length > 1 ? 'ы' : '';

        this.$notification({
          type: 'system_notification_success',
          message: `Скан${ending} успешно ${event.deleted ? 'удалён' : `добавлен${ending}`}`
        });
      },
      deleteFile (uuid) {
        this.formData.files = this.formData.files.filter(file => file.uuid !== uuid);
      },
      async onSubmit () {
        await api[this.type].saveDocument(uuid.v4(), this.elementUuid, {
          ...this.formData,
          files: this.formData.files.map(file => file.uuid)
        });

        this.$emit('close');

        this.$notification({
          type: 'system_notification_success',
          message: 'Документ успешно добавлен'
        });
      },
      async deleteDocument () {
        try {
          await api[this.type].deleteDocument(this.dataSource.uuid);

          this.$emit('close');

          this.$notification({
            type: 'system_notification_success',
            message: 'Документ успешно удалён'
          });
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Вы не можете удалить данный документ'
          });
        }
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "~common-components/src/static/css/mixins";

  .form-add {
    &__section {
      &:not(:last-child) {
        margin-bottom: 35px;
      }

      &:last-child {
        margin-bottom: 40px;
      }
    }

    &__title {
      @include font-mixin(16px, 20px, bold, $color-text-base, 0.4px);

      margin-bottom: 10px;
    }
  }

  .existing-files {
    display: flex;
    flex-wrap: wrap;
    margin-bottom: 10px;

    &__file {
      color: $color-text-base;
      display: flex;
      align-items: center;
      padding: 5px 12px;
      border-radius: 10px;
      background: $blue-250;
      margin: 0 10px 10px 0;
      min-height: 28px;
      cursor: pointer;
    }

    &__icon {
      font-size: 12px;
      margin-left: 6px;
      color: $color-grey-label;
    }
  }

  ::v-deep {
    .menu-button-delete {
      color: $color-error;

      button .col-left .icon::before {
        color: $color-error;
      }
    }
  }
</style>
